/* Plugin Template generated by Pawn Studio */

#include <sourcemod>
#include <sdktools>

public Plugin:myinfo = 
{
	name = "L4D AutoPosSave",
	author = "ArmGadge",
	description = "Warp to last checkpoint if mission failed (coop mode only)",
	version = "1.0.1.1",
	url = "http://radiowave.moe.hm/"
}

new Handle:h_gamemode = INVALID_HANDLE;
new Float:pos_memory[3];
new Float:pos_temp[3];
new Float:gametime;
new String:saveplayer[32];
new bool:iscoopmode;
new bool:memory;
new bool:trigger;
//new trig_finale_eid;

public OnPluginStart()
{
	HookEvent("round_start", Event_RoundStart);
	HookEvent("mission_lost", Event_MissionLost);
	HookEvent("create_panic_event", Event_CreatePanic);
	HookEvent("finale_start", Event_FinaleStart);
	//HookEvent("player_use", Event_PlayerUse);
	h_gamemode = FindConVar("mp_gamemode");
	
	RegAdminCmd("sm_aps_status", Cmd_Status , ADMFLAG_KICK, "show status.");
	RegAdminCmd("sm_aps_memory", Cmd_ForceMemoryFlag , ADMFLAG_KICK, "set memory flag.");
	
	LoadTranslations("plugin.l4d_autopossave");
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(trigger)
	{
		LogError("[AutoPosSave]Warning: Trigger was not released");
		trigger = false;
	}
}
		
public OnMapStart()
{
	decl String:gamemode[16];
	GetConVarString(h_gamemode, gamemode, sizeof(gamemode));
	
	if(StrEqual(gamemode, "coop")) iscoopmode = true;
	else iscoopmode = false;
	
	if(iscoopmode)
	{
		for(new i=0; i<=2; i++)
			pos_memory[i] = pos_temp[i] = 0.0;

		memory = true;
		gametime = 0.0;
		
		PrintToServer("onmapstart");
		//trig_finale_eid = FindEntityByClassname(0, "trigger_finale");
	}
}

public Event_CreatePanic(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(iscoopmode && !trigger && memory)
	{
		trigger = true;
		new userid = GetEventInt(event, "userid");
		new client = GetClientOfUserId(userid);
		
		if(!client) client = GetRandomAliveSurvivors();
		SaveClientPos(client);
		CreateTimer(1.0, TriggerRelease);
	}
}

public Event_FinaleStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(iscoopmode && memory)
	{
		if(!trigger)
		{
			new client = GetRandomAliveSurvivors();
			SaveClientPos(client);
		}
		memory = false;
	}
}

public Event_MissionLost(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(iscoopmode)
	{
		if(pos_temp[0] != 0.0 || pos_temp[1] != 0.0 || pos_temp[2] != 0.0)
		{
			pos_memory = pos_temp;
			pos_temp[0] = pos_temp[1] = pos_temp[2] = 0.0;
		}
		if(pos_memory[0] != 0.0 || pos_memory[1] != 0.0 || pos_memory[2] != 0.0)
		{
			PrintToChatAll("[AutoPosSave]%t", "ShowInfo");
			CreateTimer(30.0, VoteDelay);
		}
		memory = true;
	}
}

GetRandomAliveSurvivors()
{
	new alivesurvivor[MAXPLAYERS+1], count, randomnum;
	for(new i=1; i<MaxClients; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && (GetClientTeam(i) == 2) && IsPlayerAlive(i))
		{
			alivesurvivor[count] = i;
			count++
		}
	}
	if(count)
	{
		randomnum = GetRandomInt(0, count-1);
		return alivesurvivor[randomnum];
	}
	else return -1;
}

SaveClientPos(client)
{
	gametime = GetGameTime();
	GetClientName(client, saveplayer, sizeof(saveplayer));
	GetClientAbsOrigin(client, pos_temp);
	PrintHintTextToAll("Checkpoint reached!", saveplayer);
	//PrintToServer("possaved time=%ds, pid=%d", RoundFloat(gametime), client);
}

public Handle_VoteMenu(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		/* This is called after VoteEnd */
		CloseHandle(menu);
	}
	else if (action == MenuAction_Display)
	{
		new Handle:panel = Handle:param2;
		decl String:buffer[255];
		Format(buffer, sizeof(buffer), "%T", "VoteQuestion", param1, saveplayer, RoundFloat(gametime));
		//PrintToChatAll(buffer);
		SetPanelTitle(panel, buffer);
	}
}
 
public Handle_VoteResults(Handle:menu, 
			num_votes, 
			num_clients, 
			const client_info[][2], 
			num_items, 
			const item_info[][2])
{
	new String:choice[4], String:display[4];
	GetMenuItem(menu, item_info[0][VOTEINFO_ITEM_INDEX], choice, sizeof(choice), _, display, sizeof(display));
	if(StrEqual(choice, "yes"))
	{
		PrintToChatAll("[AutoPosSave]%t", "VotePassed", item_info[0][VOTEINFO_ITEM_VOTES], num_votes);
		PrintToServer("[AutoPosSave] Survivor warped to the last check point.");
		CreateTimer(5.0, TeleportDelay);
	}
	else PrintToChatAll("[AutoPosSave]%t", "VoteFailed", item_info[0][VOTEINFO_ITEM_VOTES], num_votes);
}
	
DoVoteMenu()
{
	if (IsVoteInProgress())
	{
		return;
	}
	
	new Handle:menu = CreateMenu(Handle_VoteMenu, MenuAction_Display);
	SetVoteResultCallback(menu, Handle_VoteResults);
	SetMenuTitle(menu, "Vote: Warp to last checkpoint? (Time: %dsec., Pos: %s)",RoundFloat(gametime) ,saveplayer);
	
	AddMenuItem(menu, "yes", "Yes");
	AddMenuItem(menu, "no", "No");

	SetMenuExitButton(menu, false);
	VoteMenuToAll(menu, 30);
}
/*
public Event_PlayerUse(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userid = GetEventInt(event, "userid");
	new client = GetClientOfUserId(userid);
	GetClientName(client, saveplayer, sizeof(saveplayer));
	new targetid = GetEventInt(event, "targetid");
	
	if(iscoopmode && memory && targetid == trig_finale_eid)
	{
		GetClientName(client, saveplayer, sizeof(saveplayer));
		GetClientAbsOrigin(client, pos_temp);
		PrintHintTextToAll("Position saved: %s", saveplayer);
		memory = false;
	}
}
*/
public Action:VoteDelay(Handle:timer){DoVoteMenu();}
public Action:TriggerRelease(Handle:timer){trigger = false;}
public Action:TeleportDelay(Handle:timer)
{
	for(new i=1; i<MaxClients; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && (GetClientTeam(i) == 2))
		{
			TeleportEntity(i, pos_memory, NULL_VECTOR, NULL_VECTOR);
		}
	}
}

public Action:Cmd_VoteMenu(client, args)
{
	DoVoteMenu();
	return Plugin_Handled;
}

public Action:Cmd_Status(client, args)
{
	PrintToConsole(client, "[AutoPosSave Status]");
	if(iscoopmode) PrintToConsole(client, "iscoopmode = true");
	else PrintToConsole(client, "iscoopmode = false");
	if(memory) PrintToConsole(client, "memory = true");
	else PrintToConsole(client, "memory = false");
	if(trigger) PrintToConsole(client, "trigger = true");
	else PrintToConsole(client, "trigger = false");
	return Plugin_Handled;
}

public Action:Cmd_ForceMemoryFlag(client, args)
{
	new String:arg1[32];
	if(!args)
	{
		PrintToConsole(client, "usage: sm_aps_memory <true|false>");
		return Plugin_Handled;
	}
	else
	{
		GetCmdArg(1, arg1, sizeof(arg1));
		if(StrEqual(arg1, "true", false)) {memory = true;}
		else if(StrEqual(arg1, "false", false)) {memory = false;}
		else PrintToConsole(client, "usage: sm_aps_memory <true|false>");
		return Plugin_Handled;
	}
}